/* Copyright 2015 Thomas Flynn */
/*This file is part of asc.

    asc is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    asc is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with asc.  If not, see <http://www.gnu.org/licenses/>.*/

package com.androidscheme.tom.myapplication;

import com.androidscheme.tom.myapplication.util.SystemUiHider;
import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.GooglePlayServicesUtil;
import com.google.android.gms.common.api.GoogleApiClient;
import com.google.android.gms.common.api.ResultCallback;
import com.google.android.gms.drive.Drive;
import com.google.android.gms.drive.DriveApi;
import com.google.android.gms.drive.DriveContents;
import com.google.android.gms.drive.DriveFile;
import com.google.android.gms.drive.DriveId;
import com.google.android.gms.drive.DriveResource;
import com.google.android.gms.drive.MetadataChangeSet;
import com.google.android.gms.drive.OpenFileActivityBuilder;
import com.google.android.gms.drive.query.Filters;
import com.google.android.gms.drive.query.Query;
import com.google.android.gms.drive.query.SearchableField;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentSender;
import android.content.pm.PackageManager;
import android.graphics.Color;
import android.graphics.Typeface;
import android.graphics.drawable.ColorDrawable;
import android.os.Bundle;
import android.os.Environment;
import android.text.method.ScrollingMovementMethod;
import android.view.KeyEvent;
import android.view.MenuItem;
import android.view.View;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.PopupMenu;
import android.widget.TextView;
import android.widget.EditText;
import android.widget.Toast;

import org.tomthebomb.ajl.Env;
import org.tomthebomb.ajl.lisp;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.Writer;
import java.util.Scanner;
import java.util.Vector;
import java.util.concurrent.BlockingQueue;
import java.util.concurrent.LinkedBlockingQueue;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;
import java.util.zip.ZipOutputStream;

import ar.com.daidalos.afiledialog.FileChooserDialog;

public class FullscreenActivity extends Activity implements
    GoogleApiClient.ConnectionCallbacks {
    //Vars for lisp stuff
    String anstr; //temp var for printing

    final BlockingQueue<String> inputQueue = new LinkedBlockingQueue<>(); //queue for user input
    Vector<String> progs = new Vector<String>(); //text of each program buffer
    int curprog = -1; //index of focused buffer
    androidlisp lisprun;
    Thread lispthread;

    localio lio = new localio(this);

    driveio dio;

    // Handle a click on a buffer title tab.
    private View.OnClickListener buffer_title_clicked =
            new View.OnClickListener() {


        @Override
        public void onClick(View v) {
            EditText sourcetext =  (EditText) findViewById(com.androidscheme.tom.myapplication.R.id.sourceView);

            progs.set(curprog, sourcetext.getText().toString()); //save current prog

            LinearLayout ll = (LinearLayout) (v.getParent());

            int i;
            for (i = 0; i < ll.getChildCount(); i++) { //locate selected prog
                if (ll.getChildAt(i) == v) {
                    break;
                }
            }

            if (curprog != i) {//move focus to new buffer
                ll.getChildAt(curprog).setBackgroundColor(Color.YELLOW); //set tab back to 'unselected' colored
                ((TextView) (ll.getChildAt(curprog))).setTextColor(Color.BLACK);
                System.out.println("Will set to " + i);
                curprog = i;
                System.out.println("Progs sz: " + progs.size());
                v.setBackgroundColor(((ColorDrawable) sourcetext.getBackground()).getColor());
                ((TextView) v).setTextColor(Color.WHITE);
                sourcetext.setText(progs.get(curprog)); //load selected prog

            } else {
                PopupMenu popup = new PopupMenu(FullscreenActivity.this, v);

                //Inflating the Popup using xml file
                popup.getMenuInflater()
                        .inflate(com.androidscheme.tom.myapplication.R.menu.popup_menu, popup.getMenu());

                //registering popup with OnMenuItemClickListener
                popup.setOnMenuItemClickListener(buffer_menu_item_clicked);
                popup.show(); //showing popup menu
            }

        }
    };

    // Handle a selection from the buffer title tab menu (save, close, etc)
    private PopupMenu.OnMenuItemClickListener buffer_menu_item_clicked
            = new PopupMenu.OnMenuItemClickListener() {
        public boolean onMenuItemClick(MenuItem item) {
            System.out.println("Clicked on " + item.getTitle());

            if (item.getTitle().equals("Discard")) {
                System.out.println("Cur prog:" + curprog);
                remove_prog(curprog);
            } else if (item.getTitle().equals("Save")) {
                lio.begin_save();
      /*      } else if (item.getTitle().equals("Save to Google Drive")) {
                dio.start_save(); */

            }
            return true;
        }
    };

    // Handle a click on the file button
    private View.OnClickListener file_button_clicked =
            new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    PopupMenu popup = new PopupMenu(FullscreenActivity.this, v);

                    popup.getMenuInflater()
                            .inflate(com.androidscheme.tom.myapplication.R.menu.plus_menu, popup.getMenu());
                    popup.setOnMenuItemClickListener(new_menu_item_clicked);
                    popup.show();
                    System.out.println(v.getClass().toString());
                }

            };

    // Handle a selection from the file menu
    private PopupMenu.OnMenuItemClickListener new_menu_item_clicked =
            new PopupMenu.OnMenuItemClickListener() {
                @Override
                public boolean onMenuItemClick(MenuItem item) {
                    System.out.println("Clicked on " + item.getTitle());
                    int res = -1;
                    final LinearLayout tablayout = (LinearLayout) findViewById(com.androidscheme.tom.myapplication.R.id.tablayout);

                    if (item.getTitle().equals("New")) {
                        newsnippet(tablayout);
                    } else if (item.getTitle().equals("Open")) {
                        lio.begin_open();
                   /* } else if (item.getTitle().equals("Open from Google Drive")) {
                        dio.start_load();*/
                    } else if (item.getTitle().equals("Using this program")) {
                        res = com.androidscheme.tom.myapplication.R.raw.info;
                    } else if (item.getTitle().equals("Scheme information")) {
                        res = com.androidscheme.tom.myapplication.R.raw.language;
                    } else if (item.getTitle().equals("License")) {
                        res = com.androidscheme.tom.myapplication.R.raw.gpl;
                    } else if (item.getTitle().equals("Hello world")) {
                        res = com.androidscheme.tom.myapplication.R.raw.hello;
                    } else if (item.getTitle().equals("Factorial")) {
                        res = com.androidscheme.tom.myapplication.R.raw.fact;
                    } else if (item.getTitle().equals("Guessing game")) {
                        res = com.androidscheme.tom.myapplication.R.raw.guess;
                    } else if (item.getTitle().equals("Triangle")) {
                        res = com.androidscheme.tom.myapplication.R.raw.triangle;
                    } else if (item.getTitle().equals("Map")) {
                        res = com.androidscheme.tom.myapplication.R.raw.map;
                    }
                    if (res != -1) {
                        newsnippet(tablayout,
                                getResources().getResourceEntryName(res),
                                string_from_resource(res));
                    } else {

                    }

                    return true;
                }
            };


    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if (savedInstanceState == null) {
            System.out.println("New instance!");
        } else {
            System.out.println("Saved instance!");
        }

        setContentView(com.androidscheme.tom.myapplication.R.layout.activity_fullscreen);

        // Load the example program. It demonstrates
        // addition, subtraction, equality, multiplication, conditional, functions, recursion
        String prog = string_from_resource(com.androidscheme.tom.myapplication.R.raw.fact);

        //ziptest();
        //localio.write_zip();
        //twilight();
        final EditText sourcetext =
                (EditText) findViewById(com.androidscheme.tom.myapplication.R.id.sourceView);
        final TextView runtext =
                (TextView) findViewById(com.androidscheme.tom.myapplication.R.id.runView);
        final EditText inputtext =
                (EditText) findViewById(com.androidscheme.tom.myapplication.R.id.inputtext);
        final LinearLayout tablayout =
                (LinearLayout) findViewById(com.androidscheme.tom.myapplication.R.id.tablayout);
        runtext.setMovementMethod(new ScrollingMovementMethod());
        if (tablayout != null) {
            init_chooser(tablayout);
        }

        //  System.out.println("ONCREAT!");
        sourcetext.setTypeface(Typeface.MONOSPACE);
        runtext.setTypeface(Typeface.MONOSPACE);
        sourcetext.setText(prog);

        lisprun = new androidlisp(runtext, inputQueue, this);
        lispthread = new Thread(lisprun);
        final ImageButton rb = (ImageButton) findViewById(com.androidscheme.tom.myapplication.R.id.runButton);

        inputtext.setOnEditorActionListener(new inputtext_action());//user input listener

        rb.setOnClickListener(new View.OnClickListener() { //run code
            public void onClick(View v) {
                runtext.setText("");
                lisprun.setProg(sourcetext.getText().toString());
                lispthread.interrupt();

                lispthread = new Thread(lisprun);
                lispthread.start();
            }
        });


        dio = new driveio(this);
        setNavVisibility(false);
    }

    //---------BEGIN GOOGLE DRIVE FUNCTIONS

    @Override
    protected void onActivityResult(final int requestCode, final int resultCode, final Intent data) {
        System.out.println("In activity result");
        super.onActivityResult(requestCode, resultCode, data);
        switch (requestCode) {
            case driveio.REQUEST_CODE_RESOLUTION:
                if (resultCode == RESULT_OK) {
                    System.out.println("Result OK?");
                    dio.mGoogleApiClient.connect();
                    if (data == null) return;
                    try {
                        Object maybe = data.getParcelableExtra(OpenFileActivityBuilder.EXTRA_RESPONSE_DRIVE_ID);
                        if ((dio.mode == dio.MODE_OPEN) &&
                                (maybe instanceof DriveId)) {
                            System.out.println("Got the drive id");
                            /*Drive.DriveApi.getFile(dio.mGoogleApiClient,
                                    ((DriveId) maybe))
                                    .open(dio.mGoogleApiClient,
                                            DriveFile.MODE_READ_ONLY,
                                            null)
                                    .setResultCallback(dio.contentcb);*/
                        } else if ((dio.mode == dio.MODE_SAVE) &&
                                (maybe instanceof DriveId)) {
                            qtoast("File saved");
                            dio.mode = dio.MODE_NONE;
                        } else {
                            System.out.println("Something other than drive id");
                        }
                    } catch (Throwable e) {
                        System.out.println(e.getLocalizedMessage());
                    }
                }
                break;
        }
    }

    @Override
    public void onConnectionSuspended(int cause) {
        System.out.println("GoogleApi connection susp");
    }

    @Override
    public void onConnected(Bundle connectionHint) {
        System.out.println("Connected to GoogleApi");
    }
    //----------END GOOGLE DRIVE FUNCTIONS

    void setNavVisibility(boolean visible) {
        int newVis = View.SYSTEM_UI_FLAG_LAYOUT_FULLSCREEN
                | View.SYSTEM_UI_FLAG_LAYOUT_HIDE_NAVIGATION
                | View.SYSTEM_UI_FLAG_LAYOUT_STABLE
                | View.SYSTEM_UI_FLAG_IMMERSIVE_STICKY;
        if (!visible) {
            newVis |= View.SYSTEM_UI_FLAG_LOW_PROFILE | View.SYSTEM_UI_FLAG_FULLSCREEN
                    | View.SYSTEM_UI_FLAG_HIDE_NAVIGATION;
        }
        getWindow().getDecorView().setSystemUiVisibility(newVis);
    }

    static void addLine(TextView tv, String str) {
        tv.setText(tv.getText() + str + "\n");
    }

    public void qtoast(String msg) {
        Toast toast = Toast.makeText(FullscreenActivity.this, msg, Toast.LENGTH_LONG);
        toast.show();
    }

    void msgbox(String msg) {
        AlertDialog alertDialog = new AlertDialog.Builder(FullscreenActivity.this).create();
        alertDialog.setTitle("Alert");
        alertDialog.setMessage(msg);
        alertDialog.setButton(AlertDialog.BUTTON_NEUTRAL, "OK",
                new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int which) {
                        dialog.dismiss();
                    }
                });
        alertDialog.show();
    }

    // Initialize the tab area
    void init_chooser(LinearLayout tablayout) {
        //System.out.println("Got layout!");
        //System.out.println("N childs: " + tablayout.getChildCount());

        TextView tv = new TextView(getApplicationContext());
        tv.setPadding(15, 0, 15, 5);
        tv.setText("file");
        tv.setBackgroundColor(Color.WHITE);
        tv.setTextColor(Color.RED);
        tablayout.addView(tv);

        tv.setOnClickListener(file_button_clicked);

        newsnippet(tablayout);//initial snippet

        // System.out.println("N childs: " + tablayout.getChildCount());
    }





    void set_prog_title(int id, String name) {
        final LinearLayout tablayout = (LinearLayout) findViewById(com.androidscheme.tom.myapplication.R.id.tablayout);
        View v = tablayout.getChildAt(id);
        ((TextView) v).setText(name);
    }

    void newsnippet(String name, String contents) {
        final LinearLayout tablayout = (LinearLayout) findViewById(com.androidscheme.tom.myapplication.R.id.tablayout);
        newsnippet(tablayout, name, contents);
    }

    void newsnippet(LinearLayout tablayout, String name, String contents) {


        TextView tv = new TextView(getApplicationContext());
        tv.setLongClickable(true);
        tv.setPadding(10, 0, 10, 5);

        tv.setBackgroundColor(Color.YELLOW);
        tv.setTextColor(Color.BLACK);
        int snippetid = Math.max(0, tablayout.getChildCount() - 1);

        if (name.equals(""))
            tv.setText("untitled" + ((snippetid == 0) ? "" : snippetid));
        else
            tv.setText(name);

        tablayout.addView(tv, snippetid);
        if (curprog == -1) {
            curprog = snippetid;
            EditText sourcetext = (EditText) findViewById(com.androidscheme.tom.myapplication.R.id.sourceView);
            sourcetext.setText(contents);
            tv.setBackgroundColor(((ColorDrawable) sourcetext.getBackground()).getColor());
            tv.setTextColor(Color.WHITE);
        }
        if (snippetid >= progs.size())
            progs.setSize(snippetid + 1);

        progs.set(snippetid, contents);

       /* tv.setOnLongClickListener(new View.OnLongClickListener() {
            public boolean onLongClick(View v) {
                v.callOnClick();
                System.out.println("Long click");
               return true;
            }
       });*/

        tv.setOnClickListener(buffer_title_clicked);

    }

    public String get_current_source() { // return current code
        final EditText sourcetext = (EditText) findViewById(com.androidscheme.tom.myapplication.R.id.sourceView);
        return sourcetext.getText().toString();
    }

    public String get_current_title() { //name of current tab
        final LinearLayout tablayout = (LinearLayout) findViewById(com.androidscheme.tom.myapplication.R.id.tablayout);
        View v = tablayout.getChildAt(curprog);
        return ((TextView) v).getText().toString();
    }

    public void remove_prog(int id) {
        progs.remove(id);
        final LinearLayout tablayout = (LinearLayout) findViewById(com.androidscheme.tom.myapplication.R.id.tablayout);
        final EditText sourcetext = (EditText) findViewById(com.androidscheme.tom.myapplication.R.id.sourceView);

        tablayout.removeViewAt(id);
        if (progs.size() > 0) {
            curprog = 0;
            View v = tablayout.getChildAt(0);
            v.setBackgroundColor(((ColorDrawable) sourcetext.getBackground()).getColor());
            sourcetext.setText(progs.get(curprog)); //load selected prog
        } else {
            curprog = -1;
            System.out.println("All windows closed");
            newsnippet(tablayout);
        }
    }

    public class inputtext_action implements TextView.OnEditorActionListener {
        public boolean onEditorAction(TextView v, int actionId, KeyEvent event) {
            final TextView runtext = (TextView) findViewById(com.androidscheme.tom.myapplication.R.id.runView);
            String str = v.getText().toString();
            addLine(runtext, str);
            inputQueue.add(str);
            System.out.println("Input queue now has " + inputQueue.size() + " eles");
            v.setText("");

            return false;
        }

    }

    void newsnippet(LinearLayout tablayout) {
        newsnippet(tablayout, "", "");
    }

    static String string_from_scanner(Scanner sc) {
        String str = "";
        while (sc.hasNextLine())
            str = str + sc.nextLine() + '\n';
        return str;
    }

    public String string_from_resource(int res) {
        InputStream is = this.getResources().openRawResource(res);
        return string_from_stream(is);
    }

    public String string_from_stream(InputStream is) {
        return string_from_scanner(new Scanner(is));
    }

    final private int REQUEST_CODE_ASK_PERMISSIONS = 1;

    @Override
    public void onRequestPermissionsResult(int requestCode, String[] permissions, int[] grantResults) {
        System.out.println("Checking permission request result...");
        System.out.println(requestCode);
        System.out.println(grantResults[0]);
        switch (requestCode) {

            case REQUEST_CODE_ASK_PERMISSIONS:
                if (grantResults[0] == PackageManager.PERMISSION_GRANTED) {
                    // Permission Granted
                    System.out.println("Beginning to save!");
                    lio.really_begin_save();
                }
        }
    }

}


