/* Copyright 2015 Thomas Flynn */
/*This file is part of asc.

    asc is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    asc is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with asc.  If not, see <http://www.gnu.org/licenses/>.*/

package com.androidscheme.tom.myapplication;

import android.app.Activity;
import android.app.Dialog;
import android.content.pm.PackageManager;
import android.os.Environment;
import android.support.v4.app.ActivityCompat;
import android.widget.EditText;
import android.widget.LinearLayout;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.util.Scanner;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;
import java.util.zip.ZipOutputStream;

import ar.com.daidalos.afiledialog.FileChooserDialog;

/**
 * Created by tom on 8/12/15.
 */



public class localio {
    localio(FullscreenActivity _act){
        act=_act;
    }

    private static final byte[] BUFFER = new byte[1024 * 1024]; //1 mb

    private static final int REQUEST_EXTERNAL_STORAGE = 1;
    private static String[] PERMISSIONS_STORAGE = {
            android.Manifest.permission.READ_EXTERNAL_STORAGE,
            android.Manifest.permission.WRITE_EXTERNAL_STORAGE
    };

    /*from stackoverflow, "appending files to a zip file with java"*/
    public static void copy(InputStream input, OutputStream output) throws IOException {

        int bytesRead;
        while ((bytesRead = input.read(BUFFER))!= -1) {
            output.write(BUFFER, 0, bytesRead);
        }
    }

    static void append_to_zip(ZipInputStream zin, ZipOutputStream zout,
                              String newfname, String newtxt){


         try {
            ZipEntry ze;
            while ((ze = zin.getNextEntry()) != null) {

                System.out.println("copy: " + ze.getName());
                if(!(ze.getName().equals(newfname))) {
                    zout.putNextEntry(ze);
                    if (!ze.isDirectory()) {
                        copy(zin, zout);
                    } else {
                        System.out.println("Skippign this entry");
                    }
                    zout.closeEntry();
                }
            }

            // now append some extra content
            ze = new ZipEntry(newfname);
            System.out.println("append: " + ze.getName());
            zout.putNextEntry(ze);
            zout.write(newtxt.getBytes());
            zout.closeEntry();
        }catch(Throwable e){
            System.out.println("Big problems");
             e.printStackTrace();
        }

        // close
        try {
            zin.close();
        }
        catch(Throwable e){
            System.out.println("Zin close except?");
        }
        try {
            zout.close();
        }catch(Throwable e){
            System.out.println("Zout close except?");
        }

    }

    static void write_zip(){
    System.out.println("Wrote a zip");

    }
    FileChooserDialog.OnFileSelectedListener FileSaveCallback =
            new FileChooserDialog.OnFileSelectedListener() {
                public void onFileSelected(Dialog source, File file) {
                    source.hide();
                    PrintWriter writer;
                    String fname = file.toString();
                    System.out.println("Attempting to write to " + fname);
                    try {
                        writer = new PrintWriter(fname, "UTF-8");
                    } catch (Exception e) {
                        String msg = "Could not write: " + e.getLocalizedMessage();
                        System.out.println(msg);
                        act.qtoast(msg);
                        return;
                    }
                    writer.print(act.get_current_source());
                    writer.close();
                    act.qtoast("File " + fname + " saved");
                    act.set_prog_title(act.curprog, file.getName());

                }

                public void onFileSelected(Dialog source, File folder, String name) {
                    source.hide();
                    onFileSelected(source, new File(folder, name));
                }

            };

    FileChooserDialog.OnFileSelectedListener FileOpenCallback = new FileChooserDialog.OnFileSelectedListener() {
        public void onFileSelected(Dialog source, File file) {
            source.hide();
            final EditText sourcetext = (EditText) act.findViewById(com.androidscheme.tom.myapplication.R.id.sourceView);
            final LinearLayout tablayout = (LinearLayout) act.findViewById(com.androidscheme.tom.myapplication.R.id.tablayout);
            act.newsnippet(tablayout, file.getName(), read_contents(file));
            //addLine(sourcetext,read_contents(file));
        }

        public void onFileSelected(Dialog source, File folder, String name) {
            //Null for opendialog
        }


    };

    void begin_open(){ //start to open local file
        File newFolder = new File(Environment.getExternalStorageDirectory(),"asc_code");
        if(!newFolder.exists()) {
            System.out.println("Does not exist!");
            newFolder.mkdir();
        }

        FileChooserDialog dialog = new FileChooserDialog(act,newFolder.toString());
        dialog.addListener(FileOpenCallback);
        dialog.show();

    }

    void really_begin_save() {

        File newFolder = new File(Environment.getExternalStorageDirectory(),"asc_code");
        if(!newFolder.exists()) {
            System.out.println("Does not exist!");
            if (newFolder.mkdir()) {
                System.out.println("Made directory");
            } else {
                System.out.println("Didn't make directory!");
            }
        }
        else{
            System.out.println("Code folder exists!");
        }
        FileChooserDialog dialog =
                new FileChooserDialog(act, newFolder.toString());
        dialog.setShowConfirmation(true,true);
        dialog.setCanCreateFiles(true);
        dialog.addListener(FileSaveCallback);
        dialog.show();
    }
    void begin_save(){ //start the save procedure by presenting file dialog box
        System.out.println("Verifying storage permissions...");

        // Check if we have write permission
        int permission = ActivityCompat.checkSelfPermission(act,
                android.Manifest.permission.WRITE_EXTERNAL_STORAGE);

        if (permission != PackageManager.PERMISSION_GRANTED) {
            System.out.println("Prompting user");
            // We don't have permission so prompt the user
            ActivityCompat.requestPermissions(
                    act,
                    PERMISSIONS_STORAGE,
                    REQUEST_EXTERNAL_STORAGE
            );

        }
        else{
            System.out.println("Already granted");
            really_begin_save();
        }

    }

    static String read_contents(File file) {
        String str = "";
        Scanner input;
        try {
            input = new Scanner(file);
        } catch (Exception e) {
            str = "Error opening file";
            return str;
        }
        return str + FullscreenActivity.string_from_scanner(input);
    }

    public static void verifyStoragePermissions(Activity activity) {

    }
    FullscreenActivity act;

}
